install.packages("rtweet")
install.packages("twitteR")
install.packages("RCurl")
install.packages("tm")
install.packages("wordcloud")
install.packages("ggthemes")
install.packages("qdap")
install.packages("dplyr")
install.packages("plotrix")
install.packages("dendextend")
install.packages("ggplot2")
install.packages("RWeka")
install.packages("reshape2")
install.packages("quanteda")
install.packages("BiocManager")
BiocManager::install("Rgraphviz")
install.packages("tidyverse")
install.packages("tidytext")
install.packages("igraph")
install.packages("ggraph")
install.packages("sentimentr")
install.packages("syuzhet")
install.packages("stringr")
install.packages("xlsx")
install.packages("wordcloud2")

require("twitteR")
require("RCurl")
require("tm")
require("wordcloud")

library(rtweet)
library("tm")
library("qdap")
library("dplyr")
library("wordcloud")
library("plotrix")
library("dendextend")
library("ggplot2")
library("ggthemes")
library("RWeka")
library("reshape2")
library("quanteda")
library(readxl)
library("SnowballC")
library("wordcloud")
library("RColorBrewer")
library("syuzhet")
library("Rgraphviz")
library(tidyverse)
library(tidytext)
library(igraph)
library(ggraph)
library(sentimentr)
library(syuzhet)
library(stringr)
library(xlsx)
library(wordcloud2)

consumer_key <- 'mVGp74gnyu3jvxuR7KzVcsxQ3'
consumer_secret <- '8VdEdjTIhlOju3nCPM77c0qVoWegDOfxjxX9ZNs81pTICJxxTJ'
access_token <- '1510909131942735874-Wbrb2q0EoLswtjlJrxTMuRg30cU6oX'
access_secret <- 'aNqcjM8QJur5QCrdCyYNEWNSgeLgRQwwnnq1nGNcjClYl'


rt <- search_tweets(
       "#glutenfree", 
       n = 5000, 
      include_rts = FALSE,
      lang="en",
       type = "recent" )

rt$text
#write_xlsx(rt, "rt.xlsx") #to create an excel file

#function to remove unnencessary terms
tryTolower <- function(x){
  y = NA
  try_error = tryCatch(tolower(x), error = function(e) e)
  if (!inherits(try_error, 'error'))
    y = tolower(x)
  return(y)
}

custom.stopwords <- c(stopwords('english'), 'glutenfree')


clean.vec<-function(text.vec){
  text.vec <- tryTolower(text.vec)
  text.vec <- removeWords(text.vec, custom.stopwords)
  text.vec <- removePunctuation(text.vec)
  text.vec <- stripWhitespace(text.vec)
  text.vec <- removeNumbers(text.vec)
  return(text.vec)
}

com.vec<-clean.vec(rt$text)
com.vec <- paste(com.vec, collapse=" ")
corpus <- VCorpus(VectorSource(com.vec))
corpus=tm_map(corpus, stemDocument) #(in sentiment analysis don't use this command)
#corpus=tm_map(corpus, removeWords, stopwords("english"))
for (j in seq(corpus_review))
{
  corpus_review [[j]] <- gsub("gluten pasta ","gluten_pasta", corpus_review [[j]])
  # corpus_review [[j]] <- gsub(“gluten flour", “gluten_flour”, corpus_review [[j]])
}

dtm <- TermDocumentMatrix(corpus)
#dtm <- DocumentTermMatrix(corpus_review)
dtm <- removeSparseTerms(dtm, 0.999)   #Remove sparse terms in the dtm
term_freq<-frequency(dtm, 30)

m <- as.matrix(dtm)
v <- sort(rowSums(m),decreasing=TRUE)
d <- data.frame(word = names(v),freq=v)

barplot(d[1:10,]$freq, las = 2, names.arg = d[1:10,]$word, col = rainbow(50), main ="Most frequent words", ylab = "Word frequencies")

#to create a generic wordcloud
set.seed(1234)
wordcloud(words = d$word, freq = d$freq,
          max.words=200, random.order=FALSE, rot.per=0.35,
          colors=brewer.pal(8, "Dark2"))

wordcloud2(d, shape = "star", size = 0.3,color = "skyblue")
wordcloud2(d, shape = "star", size = 0.3, color = "random-light", backgroundColor = "grey")

#Available presents are 'circle' (default), 'cardioid' (apple or heart shape curve, the most known polar equation), 'diamond' (alias of square), 'triangle-forward', 'triangle', 'pentagon', and 'star'.
# specific terms for the association
findAssocs(dtm, terms = c("use","gluten","love"), corlimit = 0.10)			


a=findAssocs(dtm, terms = findFreqTerms(dtm, lowfreq = 5), corlimit = 0.25)


#sentiment analysis: method syuzhet_vector
s_v <- get_sentences(com.vec)
poa_word_v <- get_tokens(s_v, pattern = "\\W")
syuzhet_vector <- get_sentiment(poa_word_v, method="syuzhet")
head(syuzhet_vector)
plot(
  syuzhet_vector[1:20],
  type="l",
  main="Plot Trajectory",
  xlab = "Narrative Time",
  ylab= "Emotional Variance"
)

# bing - binary scale with -1 for negative scores and +1 for positive scores
bing_vector <- get_sentiment(com.vec, method="bing")
head(bing_vector)
summary(bing_vector)

#affin - scale from -5 to +5
afinn_vector <- get_sentiment(com.vec, method="afinn")
head(afinn_vector)
summary(afinn_vector)

sentiments <- get_sentiments("nrc")
sentiment <- d %>% 
  inner_join(sentiments) %>% 
  count(word, sentiment, sort=TRUE) %>% 
  pivot_wider(names_from=sentiment, 
              values_from=n, 
              values_fill=0)

#wordcloud to see the most recurrent terms associated to a specific "sentiment", here "joy"!
sentiment %>% with(wordcloud(word, joy, 
                             min.freq=10,
                             random.color = FALSE,
                             colors = brewer.pal(8, "PuOr")))

#or fear! You can decide looking at the first row of the frame "sentiment"
sentiment %>% with(wordcloud(word, fear, 
                             min.freq=10,
                             random.color = FALSE,
                             colors = brewer.pal(12, "Paired")))




#another way to visualize sentiment
nrc_data <- get_nrc_sentiment(com.vec)
angry_items <- which(nrc_data$anger > 0)
s_v[angry_items]


#or joyful data

joy_items <- which(nrc_data$joy > 0)
s_v[joy_items]

#to plot emotions
barplot(
  sort(colSums(prop.table(nrc_data[, 1:8]))), 
  horiz = TRUE, 
  cex.names = 0.7, 
  las = 1, 
  main = "Emotions in Sample text", xlab="Percentage"
)


Sentimentscores=data.frame(colSums(nrc_data))
names(Sentimentscores)<- "Scores"
Sentimentscores<- cbind("Sentiment"=row.names(Sentimentscores), Sentimentscores)
rownames(Sentimentscores)<-NULL
ggplot(data = Sentimentscores, 
       aes(x=Sentiment, y=Scores))+
  geom_bar(aes(fill= Sentiment), stat = "identity")
+ theme(legend.position = "none") + 
  xlab("Sentiments")+ ylab("Scores") + 
  ggtitle("Sentiments of people behind the comments on d company")

#library(stringr)
#textbag=str_split(com.vec, pattern="\\s+")
#str(textbag)
#textbag=unlist(textbag)
#wordcloud(textbag, scale=c(6,0.7), max.words=150, min.freq = 4,
                    # random.order=FALSE, rot.per=0.35,colors=brewer.pal(8,"Dark2"))



